/*
Copyright 2002 - 2004 UnitedAdmins
Project originally created by OLO (http://olo.counter-strike.pl)

This file is part of StatsMe.

   StatsMe is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   StatsMe is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with StatsMe; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   A copy of the GNU General Public License is available in a file called COPYING.
   See README for more information.

*/

/* $Id: statsme_cs.cpp,v 1.24 2004/03/18 17:07:49 punisher Exp $ */

#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>			// DMG bits
#include "statsme.h"	// me

//struct keeping names and indexes for weapons

wpn_sel_t weapon_select_cs[] = {
	{WEAPON_CS_NONE,"none"},
	{WEAPON_CS_P228,"p228"}, //
	{WEAPON_CS_DUMMY,"dummy"}, 
	{WEAPON_CS_SCOUT,"scout"},
	{WEAPON_CS_HEGRENADE,"hegrenade"},
	{WEAPON_CS_XM1014,"xm1014"},
	{WEAPON_CS_C4,"c4"},
	{WEAPON_CS_MAC10,"mac10"},
	{WEAPON_CS_AUG,"aug"},
	{WEAPON_CS_SMOKEGRENADE,"smokegrenade"},
	{WEAPON_CS_ELITE,"elite"},
	{WEAPON_CS_FIVESEVEN,"fiveseven"},
	{WEAPON_CS_UMP45,"ump45"},
	{WEAPON_CS_SG550,"sg550"},
	{WEAPON_CS_GALIL,"galil"},
	{WEAPON_CS_FAMAS,"famas"},
	{WEAPON_CS_USP,"usp"},
	{WEAPON_CS_GLOCK18,"glock18"},
	{WEAPON_CS_AWP,"awp"},
	{WEAPON_CS_MP5NAVY,"mp5navy"},
	{WEAPON_CS_M249,"m249"},
	{WEAPON_CS_M3,"m3"},
	{WEAPON_CS_M4A1,"m4a1"},
	{WEAPON_CS_TMP,"tmp"},
	{WEAPON_CS_G3SG1,"g3sg1"},
	{WEAPON_CS_FLASHBANG,"flashbang"},
	{WEAPON_CS_DEAGLE,"deagle"},
	{WEAPON_CS_SG552,"sg552"},
	{WEAPON_CS_AK47,"ak47"},
	{WEAPON_CS_KNIFE,"knife"},
	{WEAPON_CS_P90,"p90"}
};

void EmitSound_CS(edict_t *entity, int channel, const char *sample, /*int*/float volume, float attenuation, int fFlags, int pitch) {
	//weapons/knife: _hit1, _hit2, _hit3, _hit4, _hitwall1, _slash1, _slash2, _stab, _deploy (last to skip)
	if (sample[0]=='w'&&sample[1]=='e'&&sample[8]=='k'&&sample[9]=='n'&&sample[14]!='d'){
		player_t*pPlayer = GET_PLAYER_POINTER(entity); //knife hits on wall and slash
		FireShot(pPlayer, pPlayer->weapon->id);
	}

	RETURN_META(MRES_IGNORED);
}

void SetModel_CS(edict_t *e, const char *m){
	if(e->v.owner&&m[7]=='w'&&m[8]=='_'&&m[9]=='h') {
		player_t*pPlayer = GET_PLAYER_POINTER(e->v.owner);
		PutGrenade(e, 1.75, 4, pPlayer);
		FireShot(pPlayer, 4);
	}
	RETURN_META(MRES_IGNORED);
}

void StartFrame_CS()
{
	// reset stats on restart or game commencing
	if ( sm.game_restarting && sm.game_restarting < gpGlobals->time )	{
		sm.game_restarting = 0;
		if ( sm_resetonrestart->value )	{
			for(int i = 1; i <= gpGlobals->maxClients; ++i )	
				ResetStats( &players[i] );
			memset(sm.roundstats,0,sizeof(stat_t)*4);
			memset(sm.gamestats,0,sizeof(stat_t)*4);
			memset(&sm.all_roundstats,0,sizeof(stat_t));
			memset(&sm.all_gamestats,0,sizeof(stat_t));
			sm.gm_accurate = players;
			sm.gm_killer = players;
			sm.gm_disruptive = players;
			sm.rnd_accurate = players;
			sm.rnd_killer = players;
			sm.rnd_disruptive = players;
			sm.c4_timer = 0;
			for(int j =0; j< sm.team_num; ++j){
				strcpy(sm.roundstats[j].name,  sm.team_name[j]);
				strcpy(sm.gamestats[j].name,  sm.team_name[j]);
				sm.gamestats[j].flags = 1;
			}
		}
	}
	
	// bomb counting down
	if (sm.c4_timer > 0 && sm.c4_timing < gpGlobals->time){
		sm.c4_timing = gpGlobals->time + 1.0; // next check on next second
		PARSE_MESSAGE_BEGIN( SM_C4TIMER );
		PARSE_WRITE_BYTE( --sm.c4_timer );
		PARSE_MESSAGE_END();
	}
	
	// round end - "send" event to each player
	if (sm.endround_time && sm.endround_time < gpGlobals->time)	{
		sm.endround_time = 0;
		for(int i = 1; i <= gpGlobals->maxClients; ++i) {
			player_t* pPlayer = GET_PLAYER_POINTER_I(i);
			if (pPlayer->ingame)	{
				if ( sm_rankupdate->value == 2 && ( !pPlayer->bot || sm_rankbots->value ) )
					ScorePlayerInRank( STRING(pPlayer->pEdict->v.netname), pPlayer->pRank, pPlayer->pRnd_stats );
				PARSE_MESSAGE_BEGIN( SM_ROUNDEND ,pPlayer,i );
				PARSE_MESSAGE_END();
				memset(&pPlayer->aRnd_stats, 0 ,sizeof(stat_t));
			}
		}
		sm.rnd_accurate = players;
		sm.rnd_killer = players;
		sm.rnd_disruptive = players;
		memset(sm.roundstats,0,sizeof(stat_t)*4);
		memset(&sm.all_roundstats,0,sizeof(stat_t));
		for(int j =0; j< sm.team_num; ++j)
			strcpy(sm.roundstats[j].name,  sm.team_name[j]);
	}
	
	// new round started
	if ( sm.newround_time && sm.newround_time < gpGlobals->time){
		sm.newround_time = 0;
		sm.freezeend_time = gpGlobals->time + CVAR_GET_FLOAT("mp_freezetime");
		sm.buyend_time = gpGlobals->time + (CVAR_GET_FLOAT("mp_buytime")*60);
		for(int i = 1; i <= gpGlobals->maxClients; ++i)	{
			player_t* pPlayer = GET_PLAYER_POINTER_I(i);
			if (pPlayer->ingame) {
				PARSE_MESSAGE_BEGIN( SM_ROUNDSTART ,pPlayer,i );
				PARSE_MESSAGE_END();
			}
		}
	}
	if ( sm.freezeend_time && sm.freezeend_time < gpGlobals->time) {
		sm.freezeend_time = 0;
		for(int i = 1; i <= gpGlobals->maxClients; ++i)	{
			player_t* pPlayer = GET_PLAYER_POINTER_I(i);
			if (pPlayer->ingame) {
				PARSE_MESSAGE_BEGIN( SM_FREEZETIMEEND ,pPlayer,i );
				PARSE_MESSAGE_END();
			}
		}
	}
	if ( sm.buyend_time && sm.buyend_time < gpGlobals->time) {
		sm.buyend_time = 0;
		for(int i = 1; i <= gpGlobals->maxClients; ++i)	{
			player_t* pPlayer = GET_PLAYER_POINTER_I(i);
			if (pPlayer->ingame) {
				PARSE_MESSAGE_BEGIN( SM_BUYTIMEEND ,pPlayer,i );
				PARSE_MESSAGE_END();
			}
		}
	}


	StartFrame();

	RETURN_META(MRES_IGNORED);
}

void Client_SendAudio_CS(void* mValue){
	if (mPlayer) return; //accept only global sounds
	static const char *szSound;
	switch (mState++) {
	case 1:
		szSound = (char*)mValue;
		if (!strcmp(szSound,"%!MRAD_BOMBPL")) {// "The bomb has been planted!"
			if ( sm.newround_time > gpGlobals->time ) break;//don't allow to announce bomb planting after round end
			sm.c4_timer = (int)CVAR_GET_FLOAT("mp_c4timer");
			sm.c4_timing = gpGlobals->time + 1.0;
		}
		else if ( !strcmp(szSound,"%!MRAD_terwin" )||!strcmp( szSound,"%!MRAD_ctwin" )||
			!strcmp( szSound,"%!MRAD_rounddraw" ))	{
			sm.newround_time = gpGlobals->time + 5.07;
			sm.endround_time = gpGlobals->time + 0.07; //and show end stats
			sm.c4_timer = 0; //stop bomb counting down because the round has already finished
		}
	}
}

//msg send when text is send to client or all players
void Client_TextMsg_CS(void* mValue) 
{
	switch (mState++) {
	case 1:

		if (mPlayer)
			break; //accept only global msgs

		if ( !strncmp("#Game_C", (char*)mValue , 7) ) {//  "Game Commencing!"
			sm.game_timeleft = sm.game_restarting = gpGlobals->time + 3.07;
			sm.endround_time = gpGlobals->time + 0.07;
			sm.newround_time = gpGlobals->time + 3.07;
		}
		else if (!strncmp("#Game_w", (char*)mValue , 7) ) {// "The game will restart in ..."
			sm.game_timeleft = -2;
		}
		else if (!strncmp("#Target_B", (char*)mValue , 9) || !strncmp("#Bomb_Defused", (char*)mValue , 13)) { // Target Bombed or defused, reset c4
			sm.c4_timer = 0;
		}
		else if (!strncmp("#Bomb_P", (char*)mValue , 7) ) {
			if ( sm.newround_time > gpGlobals->time ) break;//don't allow to announce bomb planting after round end
			sm.c4_timer = (int)CVAR_GET_FLOAT("mp_c4timer");
			sm.c4_timing = gpGlobals->time + 1.0;
		}
		break;
	case 2:

		if (sm.game_timeleft != -2)
			break;

		sm.game_timeleft = sm.game_restarting = gpGlobals->time + atoi( (char*)mValue );
		sm.newround_time = sm.game_timeleft;
		break;
	}

}

// msg send on player respawn/spawn
void Client_ResetHUD_End_CS(void* mValue)
{
	memset(mPlayer->aPpl_stats, 0 ,sizeof(stat_t)*33);
	memset(mPlayer->aAPpl_stats, 0, sizeof(stat_t)*33);
	mPlayer->killer = NULL;
	mPlayer->victim = NULL;
	mPlayer->damage_deathmsg = 0;
}

// message about death (top-right corner)
void Client_DeathMsg_CS(void* mValue)
{	
	static player_t *killer;
	static player_t *victim;
	static int kid;
	static int vid;
	static int hs;
	
	switch (mState++){
	case 0:
		kid = *(int*)mValue;
		killer = sm.killer = (kid > 0 && kid < 33) ? GET_PLAYER_POINTER_I(kid) : NULL;
		break;
	case 1:
		vid = *(int*)mValue;
		victim = sm.victim = (vid > 0 && vid < 33) ? GET_PLAYER_POINTER_I(vid) : NULL;
		break;
	case 2:	
		hs = *(int*)mValue;	
		break;
	case 3:
		//only if attacker and victim are valid and it's not the same player
		if (  !killer || !victim )
			break;

		if (  killer->index == victim->index )  { // enforce penalty for suicides...
				victim->pRnd_stats->deaths++;
				victim->pGm_stats->deaths++;
				victim->pRnd_stats->sk++;
				victim->pGm_stats->sk++;
				break;
		}

		const char* sWpn = (char*)mValue;

		if (sWpn[0]=='g'&&sWpn[1]=='r'&&sWpn[2]=='e') //this is "grenade"
			sWpn = "hegrenade";

		for (int i = 0; i < MAX_WEAPONS ; ++i) {

			if ( strcmp( sWpn, weapon_select_cs[i].name ) )
				continue;

			strcpy(killer->pPpl_stats[vid].name, weapon_select_cs[i].name); //save name of weapon from which you have been killed
			strcpy(victim->pAPpl_stats[kid].name, weapon_select_cs[i].name);
			killer->custom = &killer->pPpl_stats[vid];
			victim->custom = &victim->pPpl_stats[kid];
			victim->killer = killer;
			killer->victim = victim;
			victim->damage_deathmsg = hs + 1; //deathmessage with headshot

			FireKill(victim, killer, i, hs , (killer->team_index == victim->team_index) );
			break; //Nothing else to do here
		}
	}
}


// message send when player takes damage
void Client_Damage_CS(void* mValue)
{
	static int damage;
	static int bits;

	switch (mState++) {
	case 1:	
		damage = *(int*)mValue;
		break;
	case 2:
		bits = *(int*)mValue;
		break;
	case 3:

		if (!damage || !*(float*)mValue || bits)
			break; //no damage or this is just a fall or this is dmg not from bullets/grenade

		edict_t *enemy = NULL;

		if ( (enemy = mPlayer->pEdict->v.dmg_inflictor) == NULL )
			break; //no enemy

		player_t *killer = NULL;
		grenades_t* grenade = NULL;
		int weapon = 0;
		int aiming = 0;

		if (enemy->v.flags & player_bits) { // player
			killer = GET_PLAYER_POINTER(enemy);
			weapon = killer->weapon->id;
			aiming = killer->aiming_at;
		}
		else if( ( grenade = FindGrenade(enemy) ) != NULL ) { //grenade
			killer = grenade->pPlayer;
			weapon = grenade->index;
		}
		else //no grenade nor player so skip it
			break;

		if (killer) {//if this is a player

			// this is for SM_Damage_CS
			mPlayer->damage_aim = aiming;
			mPlayer->damage_attacker = killer;
			mPlayer->damage_damage = damage;
			mPlayer->damage_weapon = weapon;

			// end

			FireHit(mPlayer,killer, weapon, damage, aiming);

			// send SM_DeathMsg or SM_Damage and then SM_DeathMsg
			endfunction = mPlayer->damage_deathmsg ? Client_SM_DeathMsg : Client_SM_Damage;

			sm.killer = killer;
			sm.victim = mPlayer;
		}
	}
}

// money - second value says if the money change should flash on hud or not
void Client_Money_CS(void* mValue)
{
	switch (mState++){
	case 0:
		mPlayer->money = *(int*)mValue;
	}
}

// msg send to update current status about weapon - ammo, active weapon etc
void Client_CurWeapon_CS(void* mValue)
{
	static int iState;
	static int iId;

	switch (mState++){
	case 0:	
		iState = *(int*)mValue;
		break;
	case 1:
		if (!iState)
			break;//active weapon have iState set to 1
			
		iId = *(int*)mValue; // weapon ID
		break;
	case 2:
		if (!iState) break;
		
		int iClip = *(int*)mValue;
		
		if (iClip > -1 && iClip < mPlayer->pWpn_stats[iId].clip) 
			FireShot(mPlayer, iId);
		
		mPlayer->weapon = &mPlayer->pWpn_stats[iId];
		mPlayer->weapon->id = iId;
		strcpy(mPlayer->weapon->name, weapon_select_cs[iId].name); //save name of this weapon
		mPlayer->pWpn_stats[iId].clip = iClip;
	}
}

