/*
Copyright 2002 - 2004 UnitedAdmins
Project originally created by OLO (http://olo.counter-strike.pl)

This file is part of StatsMe.

   StatsMe is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   StatsMe is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with StatsMe; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   A copy of the GNU General Public License is available in a file called COPYING.
   See README for more information.

*/

/* $Id: statsme_mod.cpp,v 1.7 2004/03/18 17:11:23 punisher Exp $ */

#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>			// DMG bits
#include "statsme.h"	// me

wpn_sel_t weapon_select[MAX_WEAPONS];

void Client_ShowMenu(void* mValue) 
{
	mPlayer->menu_type = MENU_IDLE; //set by default that we have no menu 
	// if this is SM menu then it will be set again after it by function building menu
}

void Client_intermission_End(void* mValue)
{
	sm.endmap_time = gpGlobals->time + 2; //intermission - give some delay before displaying end stats for all ppl
}

// message gets sent when the players armor changes
void Client_Battery(void* mValue)
{
	mPlayer->armor = *(int*)mValue;  // armor ammount
}

// team is changed then this msg is send
void Client_TeamInfo(void* mValue)
{	
	if (mPlayer) return;

	static int index;

	switch (mState++) {
	case 0:
		index = *(int*)mValue;
		break;
	case 1:
		const char* team = (char*)mValue;

		int i;
		
		for(i = 0; i < sm.team_num ; ++i)
			if ( !strcmpi(sm.team_name[i],team) ) 
				break;

		//accept only new teams, max. 4 teams
		if ( i == sm.team_num && i < 4 )
			strcpy( sm.team_name[sm.team_num++], team);

		player_t*pPlayer = GET_PLAYER_POINTER_I( index );

		if ( !pPlayer->ingame && !strcmpi(GETPLAYERAUTHID(INDEXENT(index)),"BOT")) //this is bot...
		{
			edict_t* pEntity = INDEXENT(index);
			PlayerConnect( pEntity , STRING(pEntity->v.netname), "127.0.0.1:27005" );
			PlayerPutInServer( pPlayer );
		}

		strcpy(pPlayer->team_name, sm.team_name[i]); //save name of team
		pPlayer->team_index = i;
		sm.team_players[0] = 0;
		sm.team_players[1] = 0;
		sm.team_players[2] = 0;
		sm.team_players[3] = 0;
		for ( i = 1; i <= gpGlobals->maxClients; ++i )
		{
			pPlayer = GET_PLAYER_POINTER_I( i );
			sm.team_players[pPlayer->team_index]++;
		}
	}
}

// message gets sent when the players health changes
void Client_Health(void* mValue)
{
	mPlayer->health = *(int*)mValue;  // health ammount
}

//Score teams
void Client_TeamScore(void* mValue)
{
	static const char *szTeam;
	switch (mState++) {
	case 0:
		szTeam = (char*)mValue;
		break;
	case 1:
		for(int i = 0 ; i < sm.team_num; ++i) {
			if ( !strcmpi( szTeam, sm.team_name[i] ) ) {
				sm.gamestats[i].score = sm.roundstats[i].score = *(int*)mValue;
				sm.all_gamestats.score = sm.all_roundstats.score = *(int*)mValue;
				break;
			}
		}
		
		// every time when the socre is given check out under what index tm1. and tm2. should look for
		for (int e = 0; e < sm.team_num; ++e)
			for (int c = 0; c < 4 ; ++c)
				if ( *sm.teamscore_name[c] && !strcmpi(sm.teamscore_name[c],  sm.team_name[e] ) ) {
					sm.teamscore_id[c] = e;
					break;
				}
	}
}

// msg send on player respawn/spawn
void Client_ResetHUD_End(void* mValue)
{

	if ( sm_rankupdate->value == 2 && ( !mPlayer->bot || sm_rankbots->value ) ) {
		ScorePlayerInRank( STRING(mPlayer->pEdict->v.netname), mPlayer->pRank, mPlayer->pRnd_stats );
		memset(&mPlayer->aRnd_stats, 0 ,sizeof(stat_t));
	}
	memset(mPlayer->aPpl_stats, 0 ,sizeof(stat_t)*33);
	memset(mPlayer->aAPpl_stats, 0 ,sizeof(stat_t)*33);
	mPlayer->killer = NULL;
	mPlayer->victim = NULL;
	mPlayer->damage_deathmsg = 0;
}

// msg send when player requests list of weapons from server
void Client_WeaponList(void* mValue)
{
	static int wpnList;
	static int iId;
	static int iSlot;
	static const char* wpn_name;	
	
	switch (mState++) {
	case 0:
		wpn_name = (char*)mValue;
		break;
	case 1:
		iSlot = *(int*)mValue;
		break;
	case 7:
		iId = *(int*)mValue;

		if ( ( iId < MAX_WEAPONS ) && ( wpnList & (1<<iId) ) ) //check if weapon is not already listed
			break;

		wpnList |= (1<<iId);

		weapon_select[iId].iId = iId;
		strcpy(weapon_select[iId].name, ( wpn_name + 7 ) ); //trunk "weapon_" from weapon name

	}
	
}

// msg send to update current status about weapon - ammo, active weapon etc
void Client_CurWeapon(void* mValue)
{
	static int iState;
	static int iId;

	switch (mState++){
	case 0:	
		iState = *(int*)mValue;
		break;
	case 1:
		if (!iState)
			break;//active weapon have iState set to 1
			
		iId = *(int*)mValue; // weapon ID
		break;
	case 2:
		if (!iState) break;
		
		int iClip = *(int*)mValue;
		
		if (iClip > -1 && iClip < mPlayer->pWpn_stats[iId].clip) 
			FireShot(mPlayer, iId);
		
		mPlayer->weapon = &mPlayer->pWpn_stats[iId];
		mPlayer->weapon->id = iId;
		strcpy(mPlayer->weapon->name, weapon_select[iId].name); //save name of this weapon
		mPlayer->pWpn_stats[iId].clip = iClip;
	}
}

// message about death (top-right corner)
void Client_DeathMsg(void* mValue)
{	
	static player_t *killer;
	static player_t *victim;
	static int kid;
	static int vid;
	
	switch (mState++){
	case 0:
		kid = *(int*)mValue;
		killer = sm.killer = (kid > 0 && kid < 33) ? GET_PLAYER_POINTER_I(kid) : NULL;
		break;
	case 1:
		vid = *(int*)mValue;
		victim = sm.victim = (vid > 0 && vid < 33) ? GET_PLAYER_POINTER_I(vid) : NULL;
		break;
	case 2:
		//only if attacker and victim are valid and it's not the same player
		if (  !killer || !victim )
			break;

		if (  killer->index == victim->index )  { // enforce penalty for suicides...
				victim->pRnd_stats->deaths++;
				victim->pGm_stats->deaths++;
				victim->pRnd_stats->sk++;
				victim->pGm_stats->sk++;
				break;
		}

		const char* sWpn = (char*)mValue;
	
		if (sm.mod_id == MOD_VALVE) {
			if (sWpn[0]=='r'&&sWpn[1]=='p'&&sWpn[2]=='g'&&sWpn[4]=='r') //this is MOD_VALVE "rpg_rocket"
				sWpn = "rpg";
		}

		for (int i = 0; i < MAX_WEAPONS ; ++i) {

			if ( strcmp( sWpn, weapon_select[i].name ) )
				continue;

			strcpy(killer->pPpl_stats[vid].name, weapon_select[i].name); //save name of weapon from which you have been killed
			strcpy(victim->pAPpl_stats[kid].name, weapon_select[i].name);
			killer->custom = &killer->pPpl_stats[vid];
			victim->custom = &victim->pPpl_stats[kid];
			victim->killer = killer;
			killer->victim = victim;
			victim->damage_deathmsg = 1; //deathmessage with headshot

			FireKill(victim, killer, i, 0 , (killer->team_index == victim->team_index) );
			break; //Nothing else to do here
		}
	}
}
